/*
 * Functions.cpp
 *
 *  Created on: Mar 26, 2012
 *      Author: atabb
 */

//#include <gsl/gsl_multimin.h>

#include <math.h>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <complex>

#include <opencv/cv.h>
#include <opencv/cxcore.h>
#include <opencv/highgui.h>
#include <opencv2/calib3d/calib3d.hpp>

#include "opencv2/core/core.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/highgui/highgui.hpp"


//#include "DirectoryFunctions.hpp"
//#include "Calibration.hpp"
//#include "StandardImageFunctions.hpp"

#include "newmatap.h"     // newmat advanced functions
#include "newmatio.h"     // newmat headers including output functions


//void dRM_dr1(ColumnVector r, ColumnVector M, ColumnVector& drm){
//
//	double r1, r2, r3, M1, M2, M3;
//	double rnorm_square = DotProduct(r, r);
//	double rnorm = r.NormFrobenius();
//	double rnorm_3_2  = pow(rnorm, (3.0/2.0));
//
//	r1= r(1);
//	r2= r(2);
//	r3= r(3);
//
//	M1 = M(1);
//	M2 = M(2);
//	M3 = M(3);
//
//	drm(1) = (r1*cos(1/rnorm)*(M2*r3*rnorm - M3*r2*rnorm))/rnorm_3_2 - (cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm)*rnorm - (pow(r1, 2)*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - r1*(cos(1/rnorm) - 1)*rnorm*(M1*rnorm + (M1*pow(r1, 2))/rnorm + (M2*r1*r2)/rnorm + (M3*r1*r3)/rnorm) - sin(1/rnorm)*((M2*r1*r3)/rnorm - (M3*r1*r2)/rnorm) - (pow(r1, 2)*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm + (M1*r1*sin(1/rnorm))/rnorm_3_2;
//
//	drm(2) = (M2*r1*sin(1/rnorm))/rnorm_3_2 - r2*(cos(1/rnorm) - 1)*rnorm*(M1*rnorm + (M1*pow(r1, 2))/rnorm + (M2*r1*r2)/rnorm + (M3*r1*r3)/rnorm) - (r1*cos(1/rnorm)*(M1*r3*rnorm - M3*r1*rnorm))/rnorm_3_2 - sin(1/rnorm)*(M3*rnorm + (M3*pow(r1, 2))/rnorm - (M1*r1*r3)/rnorm) - (r1*r2*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - (r1*r2*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm;
//
//	drm(3) = sin(1/rnorm)*(M2*rnorm + (M2*pow(r1, 2))/rnorm - (M1*r1*r2)/rnorm) - r3*(cos(1/rnorm) - 1)*rnorm*(M1*rnorm + (M1*pow(r1, 2))/rnorm + (M2*r1*r2)/rnorm + (M3*r1*r3)/rnorm) + (r1*cos(1/rnorm)*(M1*r2*rnorm - M2*r1*rnorm))/rnorm_3_2 + (M3*r1*sin(1/rnorm))/rnorm_3_2 - (r1*r3*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - (r1*r3*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm;
//
//
//}
//
//void dRM_dr2(ColumnVector r, ColumnVector M, ColumnVector& drm){
//	double r1, r2, r3, M1, M2, M3;
//	double rnorm_square = DotProduct(r, r);
//	double rnorm = r.NormFrobenius();
//	double rnorm_3_2  = pow(rnorm, (3.0/2.0));
//
//	r1= r(1);
//	r2= r(2);
//	r3= r(3);
//
//	M1 = M(1);
//	M2 = M(2);
//	M3 = M(3);
//
//	drm(1) = sin(1/rnorm)*(M3*rnorm + (M3*pow(r2, 2))/rnorm - (M2*r2*r3)/rnorm) - r1*(cos(1/rnorm) - 1)*rnorm*(M2*rnorm + (M2*pow(r2, 2))/rnorm + (M1*r1*r2)/rnorm + (M3*r2*r3)/rnorm) + (r2*cos(1/rnorm)*(M2*r3*rnorm - M3*r2*rnorm))/rnorm_3_2 + (M1*r2*sin(1/rnorm))/rnorm_3_2 - (r1*r2*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - (r1*r2*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm;
//
//	drm(2) = sin(1/rnorm)*((M1*r2*r3)/rnorm - (M3*r1*r2)/rnorm) - (cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm)*rnorm - (pow(r2, 2)*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - r2*(cos(1/rnorm) - 1)*rnorm*(M2*rnorm + (M2*pow(r2, 2))/rnorm + (M1*r1*r2)/rnorm + (M3*r2*r3)/rnorm) - (r2*cos(1/rnorm)*(M1*r3*rnorm - M3*r1*rnorm))/rnorm_3_2 - (pow(r2, 2)*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm + (M2*r2*sin(1/rnorm))/rnorm_3_2;
//
//	drm(3) = (r2*cos(1/rnorm)*(M1*r2*rnorm - M2*r1*rnorm))/rnorm_3_2 - r3*(cos(1/rnorm) - 1)*rnorm*(M2*rnorm + (M2*pow(r2, 2))/rnorm + (M1*r1*r2)/rnorm + (M3*r2*r3)/rnorm) - sin(1/rnorm)*(M1*rnorm + (M1*pow(r2, 2))/rnorm - (M2*r1*r2)/rnorm) + (M3*r2*sin(1/rnorm))/rnorm_3_2 - (r2*r3*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - (r2*r3*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm;
//
//}
//
//void dRM_dr3(ColumnVector r, ColumnVector M, ColumnVector& drm){
//	double r1, r2, r3, M1, M2, M3;
//	double rnorm_square = DotProduct(r, r);
//	double rnorm = r.NormFrobenius();
//	double rnorm_3_2  = pow(rnorm, (3.0/2.0));
//
//	r1= r(1);
//	r2= r(2);
//	r3= r(3);
//
//	M1 = M(1);
//	M2 = M(2);
//	M3 = M(3);
//
//	drm(1) = (r3*cos(1/rnorm)*(M2*r3*rnorm - M3*r2*rnorm))/rnorm_3_2 - r1*(cos(1/rnorm) - 1)*rnorm*(M3*rnorm + (M3*pow(r3, 2))/rnorm + (M1*r1*r3)/rnorm + (M2*r2*r3)/rnorm) - sin(1/rnorm)*(M2*rnorm + (M2*pow(r3, 2))/rnorm - (M3*r2*r3)/rnorm) + (M1*r3*sin(1/rnorm))/rnorm_3_2 - (r1*r3*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - (r1*r3*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm;
//
//	drm(2) = sin(1/rnorm)*(M1*rnorm + (M1*pow(r3, 2))/rnorm - (M3*r1*r3)/rnorm) - r2*(cos(1/rnorm) - 1)*rnorm*(M3*rnorm + (M3*pow(r3, 2))/rnorm + (M1*r1*r3)/rnorm + (M2*r2*r3)/rnorm) - (r3*cos(1/rnorm)*(M1*r3*rnorm - M3*r1*rnorm))/rnorm_3_2 + (M2*r3*sin(1/rnorm))/rnorm_3_2 - (r2*r3*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - (r2*r3*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm;
//
//	drm(3) = (r3*cos(1/rnorm)*(M1*r2*rnorm - M2*r1*rnorm))/rnorm_3_2 - (cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm)*rnorm - (pow(r3, 2)*sin(1/rnorm)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/(rnorm_square) - r3*(cos(1/rnorm) - 1)*rnorm*(M3*rnorm + (M3*pow(r3, 2))/rnorm + (M1*r1*r3)/rnorm + (M2*r2*r3)/rnorm) - sin(1/rnorm)*((M1*r2*r3)/rnorm - (M2*r1*r3)/rnorm) - (pow(r3, 2)*(cos(1/rnorm) - 1)*(M1*r1*rnorm + M2*r2*rnorm + M3*r3*rnorm))/rnorm + (M3*r3*sin(1/rnorm))/rnorm_3_2;
//
//
//}


